package org.sersar.cayenne.dao.impl;

import java.util.Map;

import org.apache.log4j.Level;
import org.objectstyle.cayenne.query.SQLTemplate;

/**
 * @author Takahiro MATSUNAGA
 * @see AbstractSqlCommand
 */
public abstract class AbstractCommand extends AbstractSqlCommand {

    private Class beanClass_;

    private Map params_;

    private SQLTemplate template_;

    public AbstractCommand(Class beanClass) {
        beanClass_ = beanClass;
    }

    protected SQLTemplate createTemplate(boolean selecting) {
        template_ = new SQLTemplate(beanClass_, getSql(), selecting);
        template_.setLoggingLevel(Level.WARN);
        template_.setParameters(params_);

        return template_;
    }

    /**
     * @return beanClass
     */
    protected Class getBeanClass() {
        return beanClass_;
    }

    /**
     * @return params
     */
    protected Map getParams() {
        return params_;
    }

    /**
     * @param params
     */
    protected void setParams(Map params) {
        this.params_ = params;
    }

}
