package org.sersar.cayenne.dao.impl;

import java.util.Iterator;

import org.objectstyle.cayenne.dba.TypesMapping;
import org.objectstyle.cayenne.map.DbAttribute;
import org.objectstyle.cayenne.map.DbEntity;
import org.objectstyle.cayenne.map.ObjAttribute;
import org.objectstyle.cayenne.map.ObjEntity;
import org.sersar.cayenne.S2DataContextFactory;

/**
 * @author Takahiro MATSUNAGA
 * @see AbstractSelectCommand
 */
public class SelectAutoCommand extends AbstractSelectCommand {

    /**
     * @param s2DataContextFactory
     * @param beanClass
     */
    public SelectAutoCommand(S2DataContextFactory s2DataContextFactory, Class beanClass) {
        super(s2DataContextFactory, beanClass);
    }

    /* (Javadoc Ȃ)
     * @see org.sersar.cayenne.dao.impl.AbstractSelectCommand#setupWhere(java.lang.StringBuffer, org.objectstyle.cayenne.map.ObjEntity)
     */
    protected void setupWhere(StringBuffer sb, ObjEntity objEntity) {
        sb.append(" #chain('and' 'where')");

        DbEntity dbEntity = objEntity.getDbEntity();
        Iterator entIt = dbEntity.getAttributes().iterator();
        while (entIt.hasNext()) {
            DbAttribute dbAttr = (DbAttribute) entIt.next();
            ObjAttribute objAttr = objEntity.getAttributeForDbAttribute(dbAttr);
            String name = objAttr.getName();

            for (int i = 0; i < getArgNames().length; i++) {
                if (name.equals(getArgNames()[i])) {
                    sb.append(" #chunk($");
                    sb.append(name).append(") ");
                    sb.append(name).append(" #bindEqual($");
                    sb.append(name).append(" '");
                    sb.append(TypesMapping.getSqlNameByType(dbAttr.getType())).append("') #end");
                }
            }
        }
        sb.append(" #end ");
        if (getQuery() != null) {
            sb.append(getQuery());
        }
    }

}
