package org.sersar.cayenne.interceptors;

import java.lang.reflect.Method;

import org.aopalliance.intercept.MethodInvocation;
import org.seasar.framework.aop.interceptors.AbstractInterceptor;
import org.seasar.framework.util.MethodUtil;
import org.sersar.cayenne.dao.CayenneDaoCommand;
import org.sersar.cayenne.dao.CayenneDaoMetaData;
import org.sersar.cayenne.dao.CayenneDaoMetaDataFactory;

/**
 * @author Takahiro MATSUNAGA
 * @see AbstractInterceptor
 */
public class S2CayenneDaoInterceptor extends AbstractInterceptor {

    private CayenneDaoMetaDataFactory cayenneDaoMetaDataFactory_;

    public S2CayenneDaoInterceptor(CayenneDaoMetaDataFactory cayenneDaoMetaDataFactory) {
        cayenneDaoMetaDataFactory_ = cayenneDaoMetaDataFactory;
    }

    /* ( Javadoc)
     * @see org.aopalliance.intercept.MethodInterceptor#invoke(org.aopalliance.intercept.MethodInvocation)
     */
    public Object invoke(MethodInvocation invocation) throws Throwable {
        // AbstractȊÓÂ܂܃\bhs
        Method method = invocation.getMethod();
        if (!MethodUtil.isAbstract(method)) {
            return invocation.proceed();
        }

        // R}h̎擾
        Class daoClass = getTargetClass(invocation);
        CayenneDaoMetaData dmd = cayenneDaoMetaDataFactory_.getDaoMetaData(daoClass);
        CayenneDaoCommand cmd = dmd.getDaoCommand(method.getName());

        // R}h̎s
        return cmd.execute(invocation.getArguments());
    }

}
